diff --git a/spring-boot-project/spring-boot/src/main/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactory.java b/spring-boot-project/spring-boot/src/main/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactory.java
index e2ed862799a..8849b05f25e 100644
--- a/spring-boot-project/spring-boot/src/main/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactory.java
+++ b/spring-boot-project/spring-boot/src/main/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactory.java
@@ -66,6 +66,7 @@
 import org.springframework.boot.web.server.WebServer;
 import org.springframework.boot.web.servlet.ServletContextInitializer;
 import org.springframework.boot.web.servlet.server.AbstractServletWebServerFactory;
+import org.springframework.boot.web.servlet.server.Session;
 import org.springframework.context.ResourceLoaderAware;
 import org.springframework.core.io.ResourceLoader;
 import org.springframework.util.Assert;
@@ -354,6 +355,7 @@ protected void configureContext(Context context,
 	private void configureSession(Context context) {
 		long sessionTimeout = getSessionTimeoutInMinutes();
 		context.setSessionTimeout((int) sessionTimeout);
+		configureSessionCookie(context);
 		if (getSession().isPersistent()) {
 			Manager manager = context.getManager();
 			if (manager == null) {
@@ -376,6 +378,14 @@ private void configurePersistSession(Manager manager) {
 		((StandardManager) manager).setPathname(file.getAbsolutePath());
 	}
 
+	private void configureSessionCookie(Context context) {
+		final Session.Cookie cookie = getSession().getCookie();
+
+		if (cookie.getHttpOnly() != null) {
+			context.setUseHttpOnly(cookie.getHttpOnly());
+		}
+	}
+
 	private long getSessionTimeoutInMinutes() {
 		Duration sessionTimeout = getSession().getTimeout();
 		if (isZeroOrLess(sessionTimeout)) {
diff --git a/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactoryTests.java b/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactoryTests.java
index 049e38c4c3c..4a8cc40c7ce 100644
--- a/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactoryTests.java
+++ b/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/web/embedded/tomcat/TomcatServletWebServerFactoryTests.java
@@ -210,6 +210,17 @@ public void sessionTimeoutInMins() {
 		assertTimeout(factory, 1);
 	}
 
+	@Test
+	public void sessionCookieHttpOnly() {
+		TomcatServletWebServerFactory factory = getFactory();
+		factory.getSession().getCookie().setHttpOnly(false);
+
+		Tomcat tomcat = getTomcat(factory);
+		Context context = (Context) tomcat.getHost().findChildren()[0];
+
+		assertThat(context.getUseHttpOnly()).isEqualTo(false);
+	}
+
 	@Test
 	public void noSessionTimeout() {
 		TomcatServletWebServerFactory factory = getFactory();
